#ifndef MODULE_TRAVERSER_H_INCLUDED_
#define MODULE_TRAVERSER_H_INCLUDED_

#include <vector>
#include <string>

#include "rose.h"

namespace risc {

namespace traverser {

/**
  * \brief             Search for all class definitions
  * \return            A vector with all classes that are derived
  *                    from sc_module
  */
std::vector<SgClassDefinition*> find_all_modules();

/**
  * \brief             Search for all class definitions
  * \return            A vector with all classes that are derived
  *                    from sc_channel
  */
std::vector<SgClassDefinition*> find_all_channels();

}; // end namespace traverser

}; // end namespace risc

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */

#endif /* MODULE_TRAVERSER_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
