#ifndef EVENT_H_INCLUDED_
#define EVENT_H_INCLUDED_

#include <vector>

#include "rose.h"

#include "object.h"

namespace risc {

class Event: public Object {

public:

  /**
   * \brief default constructor
   */
  explicit Event(SgVariableDefinition *ast_node);

  /**
   * \brief Get function for the name of the ast type of the event
   * \return Name as std::string
   */
  virtual std::string get_ast_type_name();

private:
  /**
   * \brief Disabled copy constructor
   */
  Event(const Event &e);
};

typedef std::vector<Event*> EventVector;
typedef std::vector<Event*>::iterator EventVectorIter;
typedef std::vector<Event*>::const_iterator EventVectorConstIter;

}; // end namespace risc

#endif /* EVENT_H_INCLUDED_ */


/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
