#ifndef EDGE_PROPERTY_WRITER_H_INCLUDED_
#define EDGE_PROPERTY_WRITER_H_INCLUDED_

#include "segment_graph.h"
#include "../internal_representation/design.h"
#include <iostream>

namespace risc {

namespace sg {

struct EdgePropertyWriter {

  EdgePropertyWriter(Graph& graph);

  template <class Edge>
  void operator() (std::ostream &out, Edge e)
  {
    if(graph_[e].event_notification_edge_) { // blue
      //out << "[ penwidth=3, color=\"#9ACEEB\", style=dotted, constraint = false]";
      out << "[ penwidth=3, color=\"#FF0000\", style=dotted, constraint = false]";
    }

    if(graph_[e].hierarchical_communication_) { // pink
      out << "[ penwidth=3 , color=\"#EB9ACE\", style=dotted, constraint = false]" ;
    }
    
    if(PSG_MODE) out << "[label=\"" << graph_[e].time_units_ << "\"]";
  }


  /**
   * \brief The segment graph
   */
  Graph& graph_;

  friend std::ostream& operator<< (std::ostream &out,
                           const EdgePropertyWriter &epw)
  {
    return out;
  }
};

}; // end of namespace sg

}; // end of namespace risc

#endif /* EDGE_PROPERTY_WRITER_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
