#include "port_call_path.h"


risc::sg::PortCallPath::PortCallPath():
	pcp_type_(0)
	{}

risc::sg::PortCallPath::PortCallPath(std::list<SgVariableDefinition*> ports):
	pcp_type_(1),
	port_(ports)
	{}

risc::sg::PortCallPath::~PortCallPath()
{
	pcp_type_=0;
}

void risc::sg::PortCallPath::print()
{
	std::cout << " [pcp_type_=" << pcp_type_ <<"] ";
	if(pcp_type_ == 1)
	{
		for(std::list<SgVariableDefinition*>::iterator
			iter  = port_.begin();
			iter != port_.end();
			++ iter)
		{
			std::cout << "->[ " << (*iter)->get_declaration()->get_decl_item(NULL)->get_qualified_name() << " ]" ;
		}
		std::cout << std::endl;
	}
}


bool risc::sg::operator==(const risc::sg::PortCallPath &lhs , const risc::sg::PortCallPath &rhs) {
  return lhs.path_ == rhs.path_ &&
	lhs.pcp_type_ == rhs.pcp_type_ &&
	lhs.port_ == rhs.port_;
}

bool risc::sg::operator<(const risc::sg::PortCallPath &lhs,	// (RD, 11/22/18)
			 const risc::sg::PortCallPath &rhs) {
  return (lhs.pcp_type_ != rhs.pcp_type_ ? lhs.pcp_type_ < rhs.pcp_type_ :
		(lhs.port_ != rhs.port_ ? lhs.port_ < rhs.port_ :
			(lhs.path_ < rhs.path_)));
}

