// bug20180717a.cc:
// WAS: bug_notify.cpp (reported by DM 07/17/18)

#include "systemc.h"

class TOP: public sc_module {
public:
	SC_HAS_PROCESS(TOP);

	TOP(sc_module_name mn, sc_event &event)
	: ep(&event), er(event) {
		SC_THREAD(behav);
		SC_THREAD(test_notify_types);
	}

class FakeEvent{
public:
	void	notify(){}
};

	FakeEvent event;	// NOT a SystemC event! Should be ignored!

	void behav() {
		event.notify();	// NOT a SystemC notification
	}

	// other types looked into at the same time (RD, 07/23/18)
	sc_event e;	// normal event, supported
	sc_event *ep;	// event pointer, not supported
	sc_event ea[2];	// event array, not supported
	sc_event &er;	// event reference, supported

	void test_notify_types() {
		//e.notify();			// Error: No support of immediate event notification
		e.notify(SC_ZERO_TIME);		// OK
		//e.notify(sc_time(42,SC_NS));	// Error: Expected notify(SC_ZERO_TIME)
		//e.notify(42,SC_NS);		// Error: Expected notify(SC_ZERO_TIME)
		//(*ep).notify(SC_ZERO_TIME);	// no support
		//ea[1].notify(SC_ZERO_TIME);	// no support
		//er.notify(SC_ZERO_TIME);	// OK (should be resolved)
	}
};

int sc_main(int argc, char * argv[]) {
	sc_event e;
	TOP t("t", e);
	sc_start();
	return 0;
}
