// event_or_list.cc:
//
// 06/11/18 RD	extended version
// 06/11/18 DM	original version

#include <assert.h>
#include "systemc.h"

SC_MODULE(top) {
	sc_event e1;
	sc_event e2;
	int n1, n2, w1, w2, w3;

	SC_CTOR(top) {
		n1 = n2 = w1 = w2 = w3 = 0;
		SC_THREAD(notifier1);
		SC_THREAD(notifier2);
		SC_THREAD(waiter1);
		SC_THREAD(waiter2);
		SC_THREAD(waiter3);
	}

	void notifier1() {
		wait(5,SC_NS);
		std::cout << "notifier 1 sending notification!\n";
		e1.notify(SC_ZERO_TIME);
		n1 = 1;
	}

	void notifier2() {
		wait(6,SC_NS);
		std::cout << "notifier 2 sending notification!\n";
		e2.notify(SC_ZERO_TIME);
		n2 = 1;
	}

	void waiter1() {
		wait(e1);
		std::cout << "waiter 1 received notification!\n";
		w1 = 1;
	}

	void waiter2() {
		wait(e2);
		std::cout << "waiter 2 received notification!\n";
		w2 = 1;
	}

	void waiter3() {
		wait(e1 | e2);
		std::cout << "waiter 3 received notification!\n";
		w3 = 1;
	}
};

int sc_main(int argc, char** argv) {
	top t("t");
	sc_start();
	assert(t.n1 == 1);
	assert(t.n2 == 1);
	assert(t.w1 == 1);
	assert(t.w2 == 1);
	assert(t.w3 == 1);
	return 0;
}

/* ex: set softtabstop=8 tabstop=8 shiftwidth=8 expandtab: */
