// nobug20180724.cc
// (was sig_function.cpp reported by DM 07/24/18)

// classified as not-a-bug: cannot be statically analyzed (RD, 07/26/18)

#include "systemc.h"

SC_MODULE(SUB) {
	sc_out<bool> local_port0;
	sc_out<bool> local_port1;

	SC_CTOR(SUB) {
		SC_THREAD(sub_behav);
	}

	void sub_behav() {
		local_port0.write(true);
		local_port1.write(true);
	}
};

SC_MODULE(TOP) {
	SUB submod;
	sc_signal<bool> sig0;
	sc_signal<bool> sig1;

	sc_signal<bool> & sig(int index) {	// RD: odd way to model a signal "array access"?
		switch(index) {			// RD: this is not supportable with static analysis!
			case 0: return sig0;	// RD: should be re-written such that selection
			case 1: return sig1;	// RD: happens in behavior, but structure stays static.
		}
	}

	SC_CTOR(TOP):submod("submod") {
		SC_THREAD(top_behav);
	}

	void top_behav() {
		wait(SC_ZERO_TIME);
		std::cout << "sig(0) = " << sig(0).read() << "\n";	// RD: function determines which
		std::cout << "sig(1) = "<< sig(1).read() << "\n";	// RD: signal is used

		//std::cout << "sig(0) = "<< sig0.read() << "\n";	// RD: should be like this
		//std::cout << "sig(1) = "<< sig1.read() << "\n";	// RD: should be like this
	}

	void before_end_of_elaboration() {
		submod.local_port0.bind(sig(0));	// RD: port binding with function-computed target
		submod.local_port1.bind(sig(1));

		//submod.local_port0.bind(sig0);	// RD: should be like this
		//submod.local_port1.bind(sig1);
	}
};

int sc_main(int argc,char* argv[]) {
	TOP t("t");
	sc_start();
	return 0;
}
