// sensitive3.cc:
//
// 07/17/18 ZC  a simplified version for debugging
// 07/07/18 RD	regression test for threads with static sensitivity

#include <assert.h>
#include "systemc.h"

#define T 5

SC_MODULE(Top) {
	sc_event tick1, tick2;
	sc_event_or_list OrList1;

	sc_time tn_notifier, tn_waiter;
	int n_notifier, n_waiter;

	SC_CTOR(Top) {
		n_notifier = n_waiter = 0;
		OrList1 |= tick1;
		OrList1 |= tick2;
		tn_notifier = tn_waiter = SC_ZERO_TIME;
		SC_THREAD(notifier);
		SC_THREAD(waiter);
		sensitive << tick1;
		sensitive << tick2;
	}

	void notifier() {
		for(int i=0; i<T; i+=1) {
			wait(2,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": tick1 \n";
			tick1.notify(SC_ZERO_TIME);
			wait(1,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": tick2 \n";
			tick2.notify(SC_ZERO_TIME);
			n_notifier++;
		}
		tn_notifier = sc_time_stamp();
	}

	void waiter() {
		while(true) {
			//wait(OrList1);
			wait();
			std::cout << sc_time_stamp().to_string() << ": waiter  shift!\n";
			n_waiter++;
			tn_waiter = sc_time_stamp();
		}
	}

};

Top top("top");

int sc_main(int argc, char** argv) {
	sc_start();
	cout << "sensitive1 test done." << endl;
	return 0;
}

/* ex: set softtabstop=8 tabstop=8 shiftwidth=8: */
