#include <stdio.h>
#include "systemc.h"
#include <iostream>
SC_MODULE(M1)
{
  sc_event e1, e2, e3, e4, e5, e6;
  void th1(){
    wait(SC_ZERO_TIME);
    e1.notify(SC_ZERO_TIME);
    std::cout << sc_time_stamp().to_string() << std::endl;
    assert(sc_time_stamp().to_string() == "0 s");
  }
  
  void th2(){
    wait(e1);
    std::cout << "th2:";
    std::cout << sc_time_stamp().to_string() << " ";// << std::endl;
    std::cout << sc_delta_count() << std::endl;
    assert(sc_time_stamp().to_string() == "0 s");
    
    e2.notify(3, SC_NS);
  }
  
  void th3(){
    wait(e2);
    std::cout << "th3:";
    std::cout << sc_time_stamp().to_string() << " ";// << std::endl;
    std::cout << sc_delta_count() << std::endl;
    assert(sc_time_stamp().to_string() == "3 ns");
    double v = 10.005;
    e3.notify(1/v + v,SC_NS);

  }

  void th4(){
    wait(e3);
    e4.notify();
    std::cout << sc_time_stamp().to_string() << std::endl;
    assert(sc_time_stamp().to_string() == "13105 ps");
  }

  void th5(){
    wait(e4);
    e5.notify(3, SC_NS);
    std::cout << sc_time_stamp().to_string() << std::endl;
    
    assert(sc_time_stamp().to_string() == "13105 ps");
  }


  void th6(){
    wait(e5);
    e6.notify(SC_ZERO_TIME);
    std::cout << sc_time_stamp().to_string() << std::endl;
    
    assert(sc_time_stamp().to_string() == "16105 ps"); 
  }
 

  void th7(){
    wait(e6);
    double v = 0.1;
    wait(1/v, SC_NS);
    std::cout << sc_time_stamp().to_string() << std::endl;
    
    assert(sc_time_stamp().to_string() == "26105 ps");
  }


  SC_CTOR(M1){
    SC_THREAD(th1)
    SC_THREAD(th2)
    SC_THREAD(th3)
    SC_THREAD(th4)
    SC_THREAD(th5)
    SC_THREAD(th6)
    SC_THREAD(th7)
  }
};


SC_MODULE(Top)
 {
  M1 m1;
	
  SC_CTOR(Top):
  m1("m1"){}
};
	
int sc_main(int argc, char* argv[])
{
  Top top("top");
  sc_start();
  return 0;
}

// EOF
