#include "systemc.h"

class Top: public sc_module {

public:

  //sc_fifo<int> fifo1;
  sc_fifo_in<int> fifo_in_1;
  sc_fifo_out<int> fifo_out_1;

  //sc_fifo<int> fifo2;
  sc_fifo_in<int> fifo_in_2;
  sc_fifo_out<int> fifo_out_2;

  //sc_fifo<int> fifo3;
  sc_fifo_in<int> fifo_in_3;
  sc_fifo_out<int> fifo_out_3;

  SC_HAS_PROCESS(Top);

  ///////////////////// user functions without definition //////////////////////

  void thread0()
  {
    int a;
    wait(SC_ZERO_TIME);
    int b;
    no_wait();
    int c;
    wait(SC_ZERO_TIME);
    int d;
  }
  void thread1()
  {
    int a;
    wait(SC_ZERO_TIME);
    int b;
    unconditional_wait();
    int c;
    wait(SC_ZERO_TIME);
    int d;
  }
  void thread2()
  {
    int a;
    wait(SC_ZERO_TIME);
    int b;
    conditional_wait();
    int c;
    wait(SC_ZERO_TIME);
    int d;
  }
  void thread3()
  {
    int a;
    wait(SC_ZERO_TIME);
    int b;
    looped_wait();
    int c;
    wait(SC_ZERO_TIME);
    int d;
  }

  void thread4()
  {
    int a;
    wait(SC_ZERO_TIME);
    int b;
    no_wait2();
    int c;
    wait(SC_ZERO_TIME);
    int d;
  }
  void thread5()
  {
    int a;
    wait(SC_ZERO_TIME);
    int b;
    unconditional_wait2();
    int c;
    wait(SC_ZERO_TIME);
    int d;
  }
  void thread6()
  {
    int a;
    wait(SC_ZERO_TIME);
    int b;
    conditional_wait2();
    int c;
    wait(SC_ZERO_TIME);
    int d;
  }
  void thread7()
  {
    int a;
    wait(SC_ZERO_TIME);
    int b;
    looped_wait2();
    int c;
    wait(SC_ZERO_TIME);
    int d;
  }

  void thread8()
  {
    wait(SC_ZERO_TIME);
    no_annotation();
    wait(SC_ZERO_TIME);
  }

  ////////////////////// test sc_fifo_in/out //////////////////////
  int one, two, three, four;

  void thread10()
  {
    int aa;
    wait(SC_ZERO_TIME);

    int bb;
    int i;
    i = fifo_in_1.read();
    one++;

    wait(SC_ZERO_TIME);
    int cc;
  }

  void thread11()
  {
    int aa;
    wait(SC_ZERO_TIME);

    int i;
    fifo_out_1.write(i);
    two++;

    wait(SC_ZERO_TIME);
    int cc;
  }


  void thread12()
  {
    int aa;
    wait(SC_ZERO_TIME);

    int bb;
    int i;
    i = fifo_in_2.read();
    three++;

    wait(SC_ZERO_TIME);
    int cc;
  }

  void thread13()
  {
    int aa;
    wait(SC_ZERO_TIME);

    int i;
    fifo_out_2.write(i);
    four++;

    wait(SC_ZERO_TIME);
    int cc;
  }

  void thread14()
  {
    int a;
    wait(SC_ZERO_TIME);
    int i = fifo_in_2.read();
    wait(SC_ZERO_TIME);
    int b;
  }

  void thread15()
  {
    int a;
    wait(SC_ZERO_TIME);
    int i;
    i  = fifo_in_2.read();
    wait(SC_ZERO_TIME);
    int b;
  }

  void thread16()
  {
    int a;
    wait(SC_ZERO_TIME);
    int i;
    fifo_out_2.write(i);
    wait(SC_ZERO_TIME);
    int b;
  }

  int some_member;
  void thread17()
  {
    some_member = fifo_in_3.read();
  }

  //////////////////////////// Decomposition check /////////////////////////////

  #pragma RISC with_wait_decl unconditional-wait event
  int with_wait_decl();

  int with_wait_def()
  {
    wait(SC_ZERO_TIME);
    return 5;
  }

  int no_wait_decl(int i, int j);

  int no_wait_def(int c, int i)
  {
    return 6;
  }

  void thread20()
  {
    int k;
    no_wait_decl(with_wait_decl(), k);
  }

  void thread21()
  {
    int k;
    int i = no_wait_decl(with_wait_decl(), k);
  }

  void thread22()
  {
    int k;
    int i = no_wait_decl(with_wait_def(), k);
  }

  void thread23()
  {
    no_wait_decl(with_wait_def(), 2);
  }

  void thread24()
  {
    int k;
    no_wait_def(with_wait_decl(), k);
  }

  void thread25()
  {
    int k;
    int i = no_wait_def(with_wait_def(), k);
  }

  void thread26()
  {
    no_wait_def(with_wait_decl(), with_wait_decl());
  }

  void thread27()
  {
    no_wait_def(with_wait_def(), with_wait_def());
  }

  void thread28()
  {
    int i;
    i = with_wait_def();
  }

  void thread29()
  {
    int a[] = {1, 2, 12+ with_wait_decl(), 3};
  }

  void thread30()
  {
    int a[] = {1, 2, 12+ with_wait_def(), 3};
  }

  int some_func()
  {
    wait(SC_ZERO_TIME);
    return 42;
  }

  int some_member2;
  void thread31()
  {
    some_member2 = some_func();
  }

  void thread32()
  {
    some_func2(without_wait(), with_wait());
  }

  void some_func2(int a, int b)
  { }

  void thread33()
  {
    some_func3(no_wait1(), no_wait22(), with_wait_1());
  }

  int no_wait1()
  {
    return 1;
  }

  int no_wait22()
  {
    return 2;
  }

  int with_wait_1()
  {
    wait(SC_ZERO_TIME);
  }

  void some_func3(int a, int b, int c)
  { }

  void thread34()
  {
    some_func4(no_wait34(), no_wait341(), with_wait_34());
  }

  #pragma RISC no_wait34 no-wait
  int no_wait34();

  #pragma RISC no_wait341 no-wait
  int no_wait341();

  #pragma RISC with_wait_34 unconditional-wait event
  int with_wait_34();

  void some_func4(int a, int b, int c)
  { }

  void thread35()
  {
    some_func5(no_wait35(), no_wait351(), with_wait_35());
  }

  #pragma RISC no_wait35 no-wait
  int no_wait35();

  #pragma RISC no_wait351 no-wait
  int no_wait351();

  #pragma RISC with_wait_35 unconditional-wait event
  int with_wait_35();

  #pragma RISC some_func5 no-wait
  void some_func5(int a, int b, int c);

  #pragma RISC with_wait unconditional-wait event
  int with_wait();

  #pragma RISC without_wait no-wait
  int without_wait();

  void thread36()
  {
    wait(SC_ZERO_TIME);
    not_conflict_free_no_wait();
    wait(SC_ZERO_TIME);
  }

  void thread37()
  {
    wait(SC_ZERO_TIME);
    int i = not_conflict_free1_no_wait();
    wait(SC_ZERO_TIME);
  }

  void thread38()
  {
    wait(SC_ZERO_TIME);
    int i;
    i = not_conflict_free2_no_wait();
    wait(SC_ZERO_TIME);
  }

  void thread39()
  {
    wait(SC_ZERO_TIME);
    for_conflict(1, not_conflict_free3_no_wait(), 3);
    wait(SC_ZERO_TIME);
  }

  void thread40()
  {
    wait(SC_ZERO_TIME);
    not_conflict_free4_unconditional_wait();
    wait(SC_ZERO_TIME);
  }

  void thread41()
  {
    wait(SC_ZERO_TIME);
    not_conflict_free5_conditional_wait();
    wait(SC_ZERO_TIME);
  }





  void thread42()
  {
    wait(SC_ZERO_TIME);
    if(conflict_no_wait_if()) {
      wait(SC_ZERO_TIME);
    }
    wait(SC_ZERO_TIME);
  }

  void thread43()
  {
    wait(SC_ZERO_TIME);
    int i = 2;
    switch(conflict_no_wait_switch()) {

      case 1:
        i++;
      case 2:
        i--;
    }
    wait(SC_ZERO_TIME);
  }

  void thread44()
  {
    wait(SC_ZERO_TIME);
    while(conflict_no_wait_while()) {
      wait(SC_ZERO_TIME);
      wait(SC_ZERO_TIME);
    }
    wait(SC_ZERO_TIME);
  }

  void thread45()
  {
    wait(SC_ZERO_TIME);
    do {
      wait(SC_ZERO_TIME);
      wait(SC_ZERO_TIME);
    } while(conflict_no_wait_do_while());
    wait(SC_ZERO_TIME);
  }

  void thread46()
  {
    wait(SC_ZERO_TIME);
    for(int i = conflict_no_wait_for_init();;) {
      wait(SC_ZERO_TIME);
      wait(SC_ZERO_TIME);
    }
    wait(SC_ZERO_TIME);
  }

  void thread47()
  {
    wait(SC_ZERO_TIME);
    for(;conflict_no_wait_for_condition();) {
      wait(SC_ZERO_TIME);
      wait(SC_ZERO_TIME);
    }
    wait(SC_ZERO_TIME);
  }

  void thread48()
  {
    wait(SC_ZERO_TIME);
    for(;;conflict_no_wait_for_increment()) {
      wait(SC_ZERO_TIME);
      wait(SC_ZERO_TIME);
    }
    wait(SC_ZERO_TIME);
  }





  void thread49()
  {
    wait(SC_ZERO_TIME);
    while(conflict_no_wait_while_continue()) {
      wait(SC_ZERO_TIME);
      if(true) {
        continue;
      }
      wait(SC_ZERO_TIME);
    }
    wait(SC_ZERO_TIME);
  }

  void thread50()
  {
    wait(SC_ZERO_TIME);
    do {
      wait(SC_ZERO_TIME);
      if(true) {
        continue;
      }
      wait(SC_ZERO_TIME);
    } while(conflict_no_wait_do_while_continue());
    wait(SC_ZERO_TIME);
  }

  void thread51()
  {
    wait(SC_ZERO_TIME);
    for(int i = conflict_no_wait_for_init_continue();;) {
      wait(SC_ZERO_TIME);
      if(true) {
        continue;
      }
      wait(SC_ZERO_TIME);
    }
    wait(SC_ZERO_TIME);
  }

  void thread52()
  {
    wait(SC_ZERO_TIME);
    for(;conflict_no_wait_for_condition_continue();) {
      wait(SC_ZERO_TIME);
      if(true) {
        continue;
      }
      wait(SC_ZERO_TIME);
    }
    wait(SC_ZERO_TIME);
  }

  void thread53()
  {
    wait(SC_ZERO_TIME);
    for(;;conflict_no_wait_for_increment_continue()) {
      wait(SC_ZERO_TIME);
      if(true) {
        continue;
      }
      wait(SC_ZERO_TIME);
    }
    wait(SC_ZERO_TIME);
  }


  Top(sc_module_name mn):
    sc_module(mn)
  {
    #if 1
    // user non defining function declaration tests
    SC_THREAD(thread0);
    SC_THREAD(thread1);
    SC_THREAD(thread2);
    SC_THREAD(thread3);
    SC_THREAD(thread4);
    SC_THREAD(thread5);
    SC_THREAD(thread6);
    SC_THREAD(thread7);

    SC_THREAD(thread8);

    // sc_fifo_in/out tests
    SC_THREAD(thread10);
    SC_THREAD(thread11);
    SC_THREAD(thread12);
    SC_THREAD(thread13);
    SC_THREAD(thread14);
    SC_THREAD(thread15);
    SC_THREAD(thread16);
    SC_THREAD(thread17);

    // Decomposition tests
    SC_THREAD(thread20);
    SC_THREAD(thread21);
    SC_THREAD(thread22);
    SC_THREAD(thread23);
    SC_THREAD(thread24);
    SC_THREAD(thread25);

    SC_THREAD(thread26);
    SC_THREAD(thread27);
    SC_THREAD(thread28);
    SC_THREAD(thread29);
    SC_THREAD(thread30);

    // check library functions
    SC_THREAD(thread31);

    SC_THREAD(thread32);
    SC_THREAD(thread33);
    SC_THREAD(thread34);
    SC_THREAD(thread35);

    // test cases for conflict free pragma option
    SC_THREAD(thread36);
    SC_THREAD(thread37);
    SC_THREAD(thread38);
    SC_THREAD(thread39);
    SC_THREAD(thread40);
    SC_THREAD(thread41);

    // Test cases for not-conflict-free with if, switch, while, do-while
    // and 3x for (init, condition, increment)
    SC_THREAD(thread42);
    SC_THREAD(thread43);
    SC_THREAD(thread44);
    SC_THREAD(thread45);
    SC_THREAD(thread46);
    SC_THREAD(thread47);
    SC_THREAD(thread48);

    // Test cases for not-conflict-free with while, do-while, and 3x for loops
    // with a continue statment
    SC_THREAD(thread49);
    SC_THREAD(thread50);
    SC_THREAD(thread51);
    SC_THREAD(thread52);
    SC_THREAD(thread53);

    #else
    #endif
  }

  void before_end_of_elaboration()
  {
    //fifo_in_1.bind(fifo1);
    //fifo_out_1.bind(fifo1);

    //fifo_in_2.bind(fifo2);
    //fifo_out_2.bind(fifo2);

    //fifo_in_3.bind(fifo3);
    //fifo_out_3.bind(fifo3);
  }

  // expected to be in conflict with all
  void no_annotation();


  #pragma RISC no_wait conflict-free no-wait
  void no_wait();

  #pragma RISC unconditional_wait conflict-free unconditional-wait event
  void unconditional_wait();

  #pragma RISC conditional_wait conflict-free conditional-wait event
  void conditional_wait();

  #pragma RISC looped_wait conflict-free looped-wait event
  void looped_wait();


  #pragma RISC no_wait2 conflict-free no-wait
  void no_wait2();

  #pragma RISC unconditional_wait2 conflict-free unconditional-wait event
  void unconditional_wait2();

  #pragma RISC conditional_wait2 conflict-free conditional-wait event
  void conditional_wait2();

  #pragma RISC looped_wait2 conflict-free looped-wait event
  void looped_wait2();

  #pragma RISC not_conflict_free not-conflict-free no-wait
  void not_conflict_free_no_wait();

  #pragma RISC not_conflict_free1 not-conflict-free no-wait
  int not_conflict_free1_no_wait();

  #pragma RISC not_conflict_free2 not-conflict-free no-wait
  int not_conflict_free2_no_wait();

  #pragma RISC not_conflict_free3 not-conflict-free no-wait
  int not_conflict_free3_no_wait();

  void for_conflict(int a, int b, int c);

  #pragma RISC not_conflict_free4 not-conflict-free unconditional-wait event
  void not_conflict_free4_unconditional_wait();

  #pragma RISC not_conflict_free5 not-conflict-free conditional-wait event
  void not_conflict_free5_conditional_wait();


  #pragma RISC conflict_no_wait_if not-conflict-free no-wait
  bool conflict_no_wait_if();

  #pragma RISC conflict_no_wait_switch not-conflict-free no-wait
  int conflict_no_wait_switch();

  #pragma RISC conflict_no_wait_while not-conflict-free no-wait
  bool conflict_no_wait_while();

  #pragma RISC conflict_no_wait_do_while not-conflict-free no-wait
  bool conflict_no_wait_do_while();

  #pragma RISC conflict_no_wait_for_init not-conflict-free no-wait
  int conflict_no_wait_for_init();

  #pragma RISC conflict_no_wait_for_condition not-conflict-free no-wait
  bool conflict_no_wait_for_condition();

  #pragma RISC conflict_no_wait_for_increment not-conflict-free no-wait
  int conflict_no_wait_for_increment();


  #pragma RISC conflict_no_wait_while_continue not-conflict-free no-wait
  bool conflict_no_wait_while_continue();

  #pragma RISC conflict_no_wait_do_while_continue not-conflict-free no-wait
  bool conflict_no_wait_do_while_continue();

  #pragma RISC conflict_no_wait_for_init_continue not-conflict-free no-wait
  bool conflict_no_wait_for_init_continue();

  #pragma RISC conflict_no_wait_for_condition_continue not-conflict-free no-wait
  bool conflict_no_wait_for_condition_continue();

  #pragma RISC conflict_no_wait_for_increment_continue not-conflict-free no-wait
  void conflict_no_wait_for_increment_continue();
};


class Top1: public sc_module {
public:
  Top t;

  sc_fifo<int> fifo1;
  sc_fifo<int> fifo2;
  sc_fifo<int> fifo3;

  Top1(sc_module_name mn):
    t("top")
  { }

  void before_end_of_elaboration()
  {
    t.fifo_in_1.bind(fifo1);
    t.fifo_out_1.bind(fifo1);

    t.fifo_in_2.bind(fifo2);
    t.fifo_out_2.bind(fifo2);

    t.fifo_in_3.bind(fifo3);
    t.fifo_out_3.bind(fifo3);
  }
};


int sc_main(int argc, char **argv)
{
  Top1 t("top");

  sc_start();

  return 0;
}
