#include "systemc.h"

#include<vector>
int global; namespace my_ns{ int global_ns;}
class Sub: public sc_module {
public:
  SC_HAS_PROCESS(Sub);
  int &member;

  Sub(sc_module_name mn, int &param):
    sc_module(mn),
    member(param)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    member++;
  }
};

class Sub1: public sc_module {
public:
  SC_HAS_PROCESS(Sub1);
  int member1;

  Sub1(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    member1++;
  }
};

class Sub2: public sc_module {
public:
  SC_HAS_PROCESS(Sub2);
  int member2;

  Sub2(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    foo(member2);
  }

  void foo(int &ref)
  {
    ref++;
  }
};

class Sub3: public sc_module {
public:
  SC_HAS_PROCESS(Sub3);
  int member3;

  Sub3(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    foo(member3);
  }

  void foo(int &ref)
  {
    bar(ref);
  }

  void bar(int &ref)
  {
    ref++;
  }
};

class Sub4: public sc_module {
public:
  SC_HAS_PROCESS(Sub4);
  int member4;

  Sub4(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    foo(member4);
  }

  void foo(int &ref)
  {
    int &ref2 = ref;
    bar(ref2);
  }

  void bar(int &ref)
  {
    ref++;
  }
};

class Sub5: public sc_module {

public:

  SC_HAS_PROCESS(Sub5);

  Sub5(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread0);
    SC_THREAD(thread1);
    SC_THREAD(thread2);
    SC_THREAD(thread3);
    SC_THREAD(thread4);
    SC_THREAD(thread5);
    SC_THREAD(thread6);

    SC_THREAD(thread10);
    SC_THREAD(thread11);
    SC_THREAD(thread12);
    SC_THREAD(thread13);
    SC_THREAD(thread14);
    SC_THREAD(thread15);
    SC_THREAD(thread16);

    SC_THREAD(thread20);
    SC_THREAD(thread21);
    SC_THREAD(thread22);
    SC_THREAD(thread23);
    SC_THREAD(thread24);
    SC_THREAD(thread25);
    SC_THREAD(thread26);

    SC_THREAD(thread30);
    SC_THREAD(thread31);
    SC_THREAD(thread32);
    SC_THREAD(thread33);
    SC_THREAD(thread34);
    SC_THREAD(thread35);
    SC_THREAD(thread36);
  }

  int i;
  int i1;
  int i2;
  int i3;
  int a, b, c, d;
  int a1, b1, c1, d1;
  int a2, b2, c2, d2;
  int a3, b3, c3, d3;
  int array[5][5];
  int array1[5][5];
  int array2[5][5];
  int array3[5][5];

  int shared(int &ref);

  void thread0()
  {
    int NewForRead = i;
    int (*NewForRead1)[5] = array;
  }

  void thread1()
  {
    shared(i);
  }

  void thread2()
  {
    shared(array[5][5]);
  }

  void thread3()
  {
    shared(array[a][b]);
  }

  void thread4()
  {
    shared(array[a][b++]);
  }

  void thread5()
  {
    shared(array[c][d]);
  }

  void thread6()
  {
    shared(array[c][d += 1]);
  }


  int shared1(const int &ref);

  void thread10()
  {
    int NewForRead = i1;
    int (*NewForRead1)[5] = array1;
  }

  void thread11()
  {
    shared1(i);
  }

  void thread12()
  {
    shared1(array1[5][5]);
  }

  void thread13()
  {
    shared1(array1[a1][b1]);
  }

  void thread14()
  {
    shared1(array1[a1][b1++]);
  }

  void thread15()
  {
    shared1(array1[c1][d1]);
  }

  void thread16()
  {
    shared1(array1[c1][d1 += 1]);
  }


  ////////////////////////// with pragma ///////////////////

  #pragma RISC shared2 not-conflict-free no-wait
  int shared2(int &ref);

  void thread20()
  {
    int NewForRead = i2;
    int (*NewForRead1)[5] = array2;
  }

  void thread21()
  {
    shared2(i);
  }

  void thread22()
  {
    shared2(array2[5][5]);
  }

  void thread23()
  {
    shared2(array2[a2][b2]);
  }

  void thread24()
  {
    shared2(array2[a2][b2++]);
  }

  void thread25()
  {
    shared2(array2[c2][d2]);
  }

  void thread26()
  {
    shared2(array2[c2][d2 += 1]);
  }


  #pragma RISC shared3 not-conflict-free no-wait
  int shared3(const int &ref);

  void thread30()
  {
    int NewForRead = i3;
    int (*NewForRead1)[5] = array3;
  }

  void thread31()
  {
    shared3(i);
  }

  void thread32()
  {
    shared3(array3[5][5]);
  }

  void thread33()
  {
    shared3(array3[a3][b3]);
  }

  void thread34()
  {
    shared3(array3[a3][b3++]);
  }

  void thread35()
  {
    shared3(array3[c3][d3]);
  }

  void thread36()
  {
    shared3(array3[c3][d3 += 1]);
  }
};

class Top: public sc_module {

public:

  SC_HAS_PROCESS(Top);

  int member;

  void thread1()
  {
    int local = 5;
    func(local);
  }

  void thread2()
  {
    func(member);
  }

  void func(int &ref)
  {
    wait();
    ref++;
  }
  ////////////////////////

  int member2;

  void thread3()
  {
    func2(member2);
  }

  void thread4()
  {
    func2(member2);
  }

  void func2(int &ref)
  {
    wait(SC_ZERO_TIME);
    ref++;
  }

  ////////////////////////
  int i;
  int array[5];

  void thread5()
  {
    func3(array[i]);
  }

  void func3(int &ref)
  {
    wait(SC_ZERO_TIME);
    ref++;
  }

  void thread6()
  {
    int NewForRead = i;
  }

  ////////////////////////
  int i2;
  int array2[5];

  void thread7()
  {
    func4(array[i++]);
  }

  void func4(int &ref)
  {
    wait(SC_ZERO_TIME);
    ref++;
  }

  void thread8()
  {
    int NewForRead = i;
  }

  ////////////////////////
  int i3;
  int array3[5];

  void thread9()
  {
    func5(array4[i=2]);
  }

  void func5(int &ref)
  {
    wait(SC_ZERO_TIME);
    ref++;
  }

  void thread10()
  {
    int NewForRead = i;
  }

  ////////////////////////
  int i4;
  int array4[5];

  void thread11()
  {
    func6(array4[i=i+2]);
  }

  void func6(int &ref)
  {
    wait(SC_ZERO_TIME);
    ref++;
  }

  void thread12()
  {
    int NewForRead = i;
  }

  ////////////////////////
  int i5;
  int array5[5];

  void thread13()
  {
    func7(array5[i+=2]);
  }

  void func7(int &ref)
  {
    wait(SC_ZERO_TIME);
    ref++;
  }

  void thread14()
  {
    int NewForRead = i;
  }

  ////////////////////////
  std::vector<int> vector;
  int member3;
  void thread15()
  {
    vector.push_back(member3);
  }

  ////////////////////////
  int member4;
  int member5;
  void thread16()
  {
    wait();
    func8(member4);
    wait();
  }

  #pragma RISC func8 conflict-free no-wait
  void func8(int &variable)
  {
    member5++; // I know that the function is marked as conflict free, however,
               // I want to see that member5 doesn't show up in the conflict
               // table
  }

  ////////////////////////
  int member6;
  void thread17()
  {
    wait();
    func9(member6);
    wait();
  }

  void func9(int &variable)
  { }

  ////////////////////////
  int member7;

  void thread18()
  {
    func10(member7);
  }

  void func10(int &ref0)
  {
    int &ref = ref0;
    int &ref2 = ref;
    func11(ref2);
  }

  void func11(int &ref)
  {
    int &ref2 = ref;
    int &ref3 = ref2;
    int &ref4 = ref3;
    func12(ref4);
  }

  void func12(int &ref)
  {
    ref++;
  }

  void thread19()
  {
    member7++;
  }

  ////////////////////////
  int member8;

  void thread20()
  {
    func13(member8);
  }

  void func13(int &ref)
  {
    func14(ref);
  }

  void func14(int &ref)
  {
    func15(ref);
  }

  void func15(int &ref)
  {
    ref++;
  }

  void thread21()
  {
    member8++;
  }

  ////////////////////////
  int member9;
  int member10;

  void thread22()
  {
    func16(member9);
  }

  void thread23()
  {
    func16(member10);
  }

  void func16(int &ref)
  {
    func17(ref);
  }

  void func17(int &ref)
  {
    func18(ref);
  }

  void func18(int &ref)
  {
    ref++;
  }

  ////////////////////////
  void thread24()
  {
    int var;
    int &ref1 = var;
    int &ref2 = ref1;
    int &ref3 = ref2;
    int &ref4 = ref3;
    int &ref5 = ref4;
    ref5++;
  }

  ////////////////////////
  int member11;

  void thread25()
  {
    int local =5;
    func19(local);
  }

  void thread26()
  {
    func19(member11);
  }

  void func19(int &ref)
  {
    ref++;
  }

  ////////////////////////
  int member12;
  int member13;
  int member14;
  int member15;

  void thread27()
  {
    func20(member12);
  }

  void thread28()
  {
    func20(member13);
  }

  void thread29()
  {
    func20(member14);
  }

  void thread30()
  {
    func21(member15);
  }

  void thread31()
  {
    int local = 5;
    func20(local);
  }

  void thread32()
  {
    int local2 = 6;
    func21(local2);
  }

  void func20(int &ref)
  {
    int &ref2 = ref;
    int &ref3 = ref2;

    func21(ref3);
  }

  void func21(int &ref)
  {
    ref++;
  }

  void thread33()
  {
    func22(global);
  }

  void thread34()
  {
    func22(global);
  }

  void func22(int &ref)
  {
    ref++;
  }

  void thread35()
  {
    func23(my_ns::global_ns);
  }

  void thread36()
  {
    func23(my_ns::global_ns);
  }

  void func23(int &ref)
  {
    ref++;
  }

  Sub s1;
  Sub s2;
  Sub1 s11;
  Sub1 s12;
  Sub2 s21;
  Sub2 s22;
  Sub3 s31;
  Sub3 s32;
  Sub4 s41;
  Sub4 s42;
  int shared_member;
  Sub5 s5;

  Top(sc_module_name mn):
    sc_module(mn),
    s1("sub1", shared_member),
    s2("sub2", shared_member),
    s11("sub11"),
    s12("sub12"),
    s21("sub21"),
    s22("sub22"),
    s31("sub31"),
    s32("sub32"),
    s41("sub41"),
    s42("sub42"),
    s5("sub5")
  {
#if 1
    SC_THREAD(thread1);
    SC_THREAD(thread2);
    SC_THREAD(thread3);
    SC_THREAD(thread4);
    SC_THREAD(thread5);
    SC_THREAD(thread6);

    // Tests for passing an array as function parameter
    // always a pair of two threads
    SC_THREAD(thread7);
    SC_THREAD(thread8);
    SC_THREAD(thread9);
    SC_THREAD(thread10);
    SC_THREAD(thread11);
    SC_THREAD(thread12);
    SC_THREAD(thread13);
    SC_THREAD(thread14);

    // Tests for library and annotated functions
    SC_THREAD(thread15);
    SC_THREAD(thread16);
    SC_THREAD(thread17);

    SC_THREAD(thread18);
    SC_THREAD(thread19);

    SC_THREAD(thread20);
    SC_THREAD(thread21);

    SC_THREAD(thread22);
    SC_THREAD(thread23);

    SC_THREAD(thread24);

    SC_THREAD(thread25);
    SC_THREAD(thread26);

    SC_THREAD(thread27);
    SC_THREAD(thread28);
    SC_THREAD(thread29);
    SC_THREAD(thread30);
    SC_THREAD(thread31);
    SC_THREAD(thread32);
    SC_THREAD(thread33);
    SC_THREAD(thread34);
    SC_THREAD(thread35);
    SC_THREAD(thread36);
#endif
  }

  void before_end_of_elaboration()
  { }
};

int sc_main(int argc, char **argv)
{
  Top t("top");

  sc_start();

  return 0;
}
