#include "systemc.h"

class TimeAdvanceTable: public sc_module {
public:

  SC_HAS_PROCESS(TimeAdvanceTable);

  sc_event event_1;
  sc_event event_2;
  sc_event event_3;

  void thread1()
  {
    wait(SC_ZERO_TIME);

    wait(5, SC_SEC);

    bool test = false;

    if(test) {

      wait(10, SC_SEC);

    } else {

      wait(20, SC_SEC);

    }

    wait(25, SC_SEC);
  }

  void thread2()
  {
    wait(SC_ZERO_TIME);

    wait(5, SC_SEC);

    bool test = false;

    if(test) {

      wait(10, SC_SEC);

    } else {

      wait(SC_ZERO_TIME);

    }

    wait(25, SC_SEC);

  }

  void thread3()
  {
    wait(SC_ZERO_TIME);

    wait(5, SC_NS);

    bool test = false;

    if(test) {

      wait(10, SC_PS);

    } else {

      wait(SC_ZERO_TIME);

    }

    wait(25, SC_FS);
  }

  void thread4()
  {
    wait(5,SC_SEC);

    helper_thread4();

    wait(5,SC_SEC);

  }

  void helper_thread4()
  {
    wait(5,SC_SEC);
  }

  TimeAdvanceTable(sc_module_name mn):
      sc_module(mn)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
    SC_THREAD(thread3);
    SC_THREAD(thread4);
  }
};

#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  TimeAdvanceTable mm("mm");

  sc_start();
  return 0;
}
#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
